// Code generated by mockery v2.53.0. DO NOT EDIT.

package client

import (
	context "context"

	cty "github.com/zclconf/go-cty/cty"
	gen "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/pkg/protos/gen"
	grpc "google.golang.org/grpc"

	mock "github.com/stretchr/testify/mock"

	statemachine "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/pkg/statemachine"

	time "time"
)

// MockClient is an autogenerated mock type for the Client type
type MockClient struct {
	mock.Mock
}

// Close provides a mock function with no fields
func (_m *MockClient) Close() error {
	ret := _m.Called()

	if len(ret) == 0 {
		panic("no return value specified for Close")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func() error); ok {
		r0 = rf()
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// CreatePipelineJWT provides a mock function with given fields: ctx, pipelineID, audience, expiration
func (_m *MockClient) CreatePipelineJWT(ctx context.Context, pipelineID string, audience string, expiration time.Time) (string, error) {
	ret := _m.Called(ctx, pipelineID, audience, expiration)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipelineJWT")
	}

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, time.Time) (string, error)); ok {
		return rf(ctx, pipelineID, audience, expiration)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string, time.Time) string); ok {
		r0 = rf(ctx, pipelineID, audience, expiration)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string, time.Time) error); ok {
		r1 = rf(ctx, pipelineID, audience, expiration)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateVCSTokenForPipeline provides a mock function with given fields: ctx, pipelineID, vcsProviderID
func (_m *MockClient) CreateVCSTokenForPipeline(ctx context.Context, pipelineID string, vcsProviderID string) (*gen.CreateVCSTokenForPipelineResponse, error) {
	ret := _m.Called(ctx, pipelineID, vcsProviderID)

	if len(ret) == 0 {
		panic("no return value specified for CreateVCSTokenForPipeline")
	}

	var r0 *gen.CreateVCSTokenForPipelineResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string) (*gen.CreateVCSTokenForPipelineResponse, error)); ok {
		return rf(ctx, pipelineID, vcsProviderID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string) *gen.CreateVCSTokenForPipelineResponse); ok {
		r0 = rf(ctx, pipelineID, vcsProviderID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gen.CreateVCSTokenForPipelineResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string) error); ok {
		r1 = rf(ctx, pipelineID, vcsProviderID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetJob provides a mock function with given fields: ctx, jobID
func (_m *MockClient) GetJob(ctx context.Context, jobID string) (*gen.Job, error) {
	ret := _m.Called(ctx, jobID)

	if len(ret) == 0 {
		panic("no return value specified for GetJob")
	}

	var r0 *gen.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*gen.Job, error)); ok {
		return rf(ctx, jobID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *gen.Job); ok {
		r0 = rf(ctx, jobID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gen.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, jobID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipeline provides a mock function with given fields: ctx, pipelineID
func (_m *MockClient) GetPipeline(ctx context.Context, pipelineID string) (*gen.Pipeline, error) {
	ret := _m.Called(ctx, pipelineID)

	if len(ret) == 0 {
		panic("no return value specified for GetPipeline")
	}

	var r0 *gen.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*gen.Pipeline, error)); ok {
		return rf(ctx, pipelineID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *gen.Pipeline); ok {
		r0 = rf(ctx, pipelineID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gen.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, pipelineID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineActionOutputs provides a mock function with given fields: ctx, pipelineID, actionPaths
func (_m *MockClient) GetPipelineActionOutputs(ctx context.Context, pipelineID string, actionPaths []string) ([]*gen.PipelineActionOutputs, error) {
	ret := _m.Called(ctx, pipelineID, actionPaths)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineActionOutputs")
	}

	var r0 []*gen.PipelineActionOutputs
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, []string) ([]*gen.PipelineActionOutputs, error)); ok {
		return rf(ctx, pipelineID, actionPaths)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, []string) []*gen.PipelineActionOutputs); ok {
		r0 = rf(ctx, pipelineID, actionPaths)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*gen.PipelineActionOutputs)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, []string) error); ok {
		r1 = rf(ctx, pipelineID, actionPaths)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplate provides a mock function with given fields: ctx, pipelineID
func (_m *MockClient) GetPipelineTemplate(ctx context.Context, pipelineID string) ([]byte, error) {
	ret := _m.Called(ctx, pipelineID)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplate")
	}

	var r0 []byte
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]byte, error)); ok {
		return rf(ctx, pipelineID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []byte); ok {
		r0 = rf(ctx, pipelineID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]byte)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, pipelineID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineVariables provides a mock function with given fields: ctx, pipelineID
func (_m *MockClient) GetPipelineVariables(ctx context.Context, pipelineID string) (*gen.GetPipelineVariablesResponse, error) {
	ret := _m.Called(ctx, pipelineID)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineVariables")
	}

	var r0 *gen.GetPipelineVariablesResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*gen.GetPipelineVariablesResponse, error)); ok {
		return rf(ctx, pipelineID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *gen.GetPipelineVariablesResponse); ok {
		r0 = rf(ctx, pipelineID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gen.GetPipelineVariablesResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, pipelineID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetRepositoryArchive provides a mock function with given fields: ctx, vcsProviderID, repositoryPath, ref
func (_m *MockClient) GetRepositoryArchive(ctx context.Context, vcsProviderID string, repositoryPath string, ref *string) (grpc.ServerStreamingClient[gen.GetRepositoryArchiveResponse], error) {
	ret := _m.Called(ctx, vcsProviderID, repositoryPath, ref)

	if len(ret) == 0 {
		panic("no return value specified for GetRepositoryArchive")
	}

	var r0 grpc.ServerStreamingClient[gen.GetRepositoryArchiveResponse]
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, *string) (grpc.ServerStreamingClient[gen.GetRepositoryArchiveResponse], error)); ok {
		return rf(ctx, vcsProviderID, repositoryPath, ref)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string, *string) grpc.ServerStreamingClient[gen.GetRepositoryArchiveResponse]); ok {
		r0 = rf(ctx, vcsProviderID, repositoryPath, ref)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(grpc.ServerStreamingClient[gen.GetRepositoryArchiveResponse])
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string, *string) error); ok {
		r1 = rf(ctx, vcsProviderID, repositoryPath, ref)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SetJobStatus provides a mock function with given fields: ctx, jobID, status
func (_m *MockClient) SetJobStatus(ctx context.Context, jobID string, status string) (*gen.Job, error) {
	ret := _m.Called(ctx, jobID, status)

	if len(ret) == 0 {
		panic("no return value specified for SetJobStatus")
	}

	var r0 *gen.Job
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string) (*gen.Job, error)); ok {
		return rf(ctx, jobID, status)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string) *gen.Job); ok {
		r0 = rf(ctx, jobID, status)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*gen.Job)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string) error); ok {
		r1 = rf(ctx, jobID, status)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SetPipelineActionOutputs provides a mock function with given fields: ctx, pipelineID, actionPath, outputs
func (_m *MockClient) SetPipelineActionOutputs(ctx context.Context, pipelineID string, actionPath string, outputs map[string]cty.Value) error {
	ret := _m.Called(ctx, pipelineID, actionPath, outputs)

	if len(ret) == 0 {
		panic("no return value specified for SetPipelineActionOutputs")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, map[string]cty.Value) error); ok {
		r0 = rf(ctx, pipelineID, actionPath, outputs)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SetPipelineActionStatus provides a mock function with given fields: ctx, pipelineID, actionPath, state
func (_m *MockClient) SetPipelineActionStatus(ctx context.Context, pipelineID string, actionPath string, state statemachine.NodeStatus) error {
	ret := _m.Called(ctx, pipelineID, actionPath, state)

	if len(ret) == 0 {
		panic("no return value specified for SetPipelineActionStatus")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, statemachine.NodeStatus) error); ok {
		r0 = rf(ctx, pipelineID, actionPath, state)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SubscribeToJobCancellationEvent provides a mock function with given fields: ctx, jobID
func (_m *MockClient) SubscribeToJobCancellationEvent(ctx context.Context, jobID string) (grpc.ServerStreamingClient[gen.JobCancellationEventResponse], error) {
	ret := _m.Called(ctx, jobID)

	if len(ret) == 0 {
		panic("no return value specified for SubscribeToJobCancellationEvent")
	}

	var r0 grpc.ServerStreamingClient[gen.JobCancellationEventResponse]
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (grpc.ServerStreamingClient[gen.JobCancellationEventResponse], error)); ok {
		return rf(ctx, jobID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) grpc.ServerStreamingClient[gen.JobCancellationEventResponse]); ok {
		r0 = rf(ctx, jobID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(grpc.ServerStreamingClient[gen.JobCancellationEventResponse])
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, jobID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// WriteLogs provides a mock function with given fields: ctx, jobID, startOffset, buffer
func (_m *MockClient) WriteLogs(ctx context.Context, jobID string, startOffset int32, buffer []byte) error {
	ret := _m.Called(ctx, jobID, startOffset, buffer)

	if len(ret) == 0 {
		panic("no return value specified for WriteLogs")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, int32, []byte) error); ok {
		r0 = rf(ctx, jobID, startOffset, buffer)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewMockClient creates a new instance of MockClient. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockClient(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockClient {
	mock := &MockClient{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
